#include <windows.h>
#include "init_D3D.h"
#include "decl_init_D3D.h"
#include "tutor.h"
#include "decl_vect_matr.h"

#define LONG_FENETRE 300
#define LARG_FENETRE 300

LRESULT CALLBACK MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	return DefWindowProc( hWnd, msg, wParam, lParam );
}

INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR, INT )
{
    // Enregistre la classe de la fentre
    WNDCLASSEX wc = {
		sizeof(WNDCLASSEX),
		CS_CLASSDC, MsgProc,
		0L, 0L,
		GetModuleHandle(NULL),
		NULL, NULL, NULL, NULL,
		"SuperBattle", NULL };

		RegisterClassEx( &wc );

		// Cration de la fentre d'application
		HWND hWnd = CreateWindow(
		"Superbattle", "Superbattle",
		WS_OVERLAPPEDWINDOW,
		100, 100, LONG_FENETRE, LARG_FENETRE * 2,
		GetDesktopWindow(),
		NULL, wc.hInstance, NULL );

		//Cration des fentres filles
		HWND hCtrl_1 = CreateWindow("EDIT", "", WS_CHILD|WS_VISIBLE, 0, 0, LONG_FENETRE, LARG_FENETRE, hWnd, NULL, hInst, NULL);

		HWND hCtrl_2 = CreateWindow("EDIT", "", WS_CHILD|WS_VISIBLE, 0, LARG_FENETRE + 1, LONG_FENETRE, LARG_FENETRE, hWnd, NULL, hInst, NULL);

		// Initialise Direct3D

		if(( SUCCEEDED( InitD3D(hCtrl_1, LONG_FENETRE, LARG_FENETRE, &obj_Direct3D, &obj_Direct3DDevice))
		&&
		SUCCEEDED( InitD3D(hCtrl_2, LONG_FENETRE, LARG_FENETRE, &obj_Direct3D2, &obj_Direct3DDevice2))
		) == E_FAIL)
			return -1;

		_module_ *module1 = new _module_;
		_module_ *module2 = new _module_;

		module1->position_cam.x = 0.0f;
		module1->position_cam.y = 0.0f;
		module1->position_cam.z = -70.0f;
		module1->monde = identite();
		module1->rot_cam = 0.0f;
		module1->coef_rotation_module = 0.0f;
		module1->coef_vitesse_module = 0.0f;
		module1->coef_cam = 0.0f;
		module1->module_rot = 0.0f;
		module1->coord_0.x = 0.0f;
		module1->coord_0.y = 0.0f;
		module1->coord_0.z = -50.0f;
		module1->rayon = 20;
		module1->collision = 0;
		module1->missile = NULL;

		module2->position_cam.x = 0.0f;
		module2->position_cam.y = 0.0f;
		module2->position_cam.z = -70.0f;
		module2->monde = identite();
		module2->rot_cam = 0.0f;
		module2->coef_rotation_module = 0.0f;
		module2->coef_vitesse_module = 0.0f;
		module2->coef_cam = 0.0f;
		module2->module_rot = 0.0f;
		module2->coord_0.x = 0.0f;
		module2->coord_0.y = 0.0f;
		module2->coord_0.z = 50.0f;
		module2->rayon = 20;
		module2->collision = 0;
		module2->missile = NULL;

		ShowWindow(hWnd, SW_SHOWDEFAULT);
		UpdateWindow(hWnd);

		MSG msg;
		ZeroMemory( &msg, sizeof(msg) );

		while( msg.message!=WM_QUIT )
			if( PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE ) )
			{
				TranslateMessage( &msg );
				DispatchMessage( &msg );
			}
   
		UnregisterClass("Superbattle", wc.hInstance);
    
	return 0;
}
